/* mpqs_eval.s
   Written by T. Kleinjung
   6/13/04: Hacked up for use in GGNFS by Chris Monico.
                                                                                                       
   Copyright (C) 2002 Jens Franke, T.Kleinjung
   This file is part of gnfs4linux, distributed under the terms of the
   GNU General Public Licence and WITHOUT ANY WARRANTY.
                                                                                                       
   You should have received a copy of the GNU General Public License along
   with this program; see the file COPYING.  If not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   2111-1307, USA.
*/

	.align	16
	.globl asm_evaluate
	# asm_evaluate(sievebegin,sieveend,buffer,nmax):
	# scans sievearray between sievebegin and sieveend for entries
	# >127 and stores them in buffer (2 Bytes), stores at most nmax
	# entries, returns number of stored entries

	# edx: counts entries found so far
	# esi: points to location of array we are investigating
	# edi: points at end of array (=sieveend)
	# mm7: 0
	# mm0-3:
	# ebx, ecx:

	# ca 36 Tz fuer main loop, ca 52*512 insgesamt , verbessern!!!

asm_evaluate:
	pushl %edi
	pushl %esi
	pushl %ebx


	movl 16(%esp),%esi
	movl 20(%esp),%edi
	xorl %edx,%edx
	pxor %mm7,%mm7

	jmp entry32

loop32:
	leal 32(%esi),%esi
	movq %mm7,-32(%esi)
	movq %mm7,-24(%esi)
	movq %mm7,-16(%esi)
	movq %mm7,-8(%esi)

entry32:
	cmpl %edi,%esi
	jz end

	movq (%esi),%mm0
	movq 8(%esi),%mm1
	movq 16(%esi),%mm2
	movq 24(%esi),%mm3

	por %mm0,%mm1
	por %mm2,%mm3
	por %mm1,%mm3

	movd %mm3,%ebx
	psrlq $32,%mm3
	movd %mm3,%ecx
	orl %ebx,%ecx
	and $0x80808080,%ecx
	jz loop32

	movl $32,%ecx
loop1:
	movb (%esi),%al
	movb $0,(%esi)
	leal 1(%esi),%esi
	andb $128,%al
	jnz found
entry1:
	decl %ecx
	jnz loop1
	jmp entry32

found:
	movl %esi,%eax
	decl %eax
	subl 16(%esp),%eax
	movl 24(%esp),%ebx
	movl %eax,(%ebx,%edx,2)  # beschreibt noch die nchsten 2 Byte
	# verbessern !!!
	incl %edx
	cmpl %edx,28(%esp)
	ja entry1
	jmp loop0entry

loop0:
	movb $0,(%esi)
	leal 1(%esi),%esi
loop0entry:
	decl %ecx
	jnz loop0

loop032:
	cmpl %edi,%esi
	jz end

	leal 32(%esi),%esi
	movq %mm7,-32(%esi)
	movq %mm7,-24(%esi)
	movq %mm7,-16(%esi)
	movq %mm7,-8(%esi)
	jmp loop032

end:
	emms
	movl %edx,%eax
	popl %ebx
	popl %esi
	popl %edi
	ret

	.align	16
	.globl asm_evaluate16

asm_evaluate16:
	pushl %edi
	pushl %esi
	pushl %ebx


	movl 16(%esp),%esi
	movl 20(%esp),%edi
	xorl %edx,%edx
	pxor %mm7,%mm7

	jmp entry32a

loop32a:
	leal 16(%esi),%esi
	movq %mm7,-16(%esi)
	movq %mm7,-8(%esi)

entry32a:
	cmpl %edi,%esi
	jz enda

	movq (%esi),%mm0
	movq 8(%esi),%mm1

	por %mm0,%mm1

	movd %mm1,%ebx
	psrlq $32,%mm1
	movd %mm1,%ecx
	orl %ebx,%ecx
	and $0x80808080,%ecx
	jz loop32a

	movl $16,%ecx
loop1a:
	movb (%esi),%al
	movb $0,(%esi)
	leal 1(%esi),%esi
	andb $128,%al
	jnz founda
entry1a:
	decl %ecx
	jnz loop1a
	jmp entry32a

founda:
	movl %esi,%eax
	decl %eax
	subl 16(%esp),%eax
	movl 24(%esp),%ebx
	movl %eax,(%ebx,%edx,2)
	incl %edx
	cmpl %edx,28(%esp)
	ja entry1a

loop0a:
	movb $0,(%esi)
	leal 1(%esi),%esi
	decl %ecx
	jnz loop0a

loop032a:
	cmpl %esi,%edi
	jz enda

	leal 16(%esi),%esi
	movq %mm7,-16(%esi)
	movq %mm7,-8(%esi)
	jmp loop032a

enda:
	emms
	movl %edx,%eax
	popl %ebx
	popl %esi
	popl %edi
	ret
